<?php
/*
	JoomlaXTC Image Wall
	
	version 1.0.0
	
	Copyright (C) 2011  Monev Software LLC.	All Rights Reserved.
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
	THIS LICENSE IS NOT EXTENSIVE TO ACCOMPANYING FILES UNLESS NOTED.

	See COPYRIGHT.php for more information.
	See LICENSE.php for more information.
	
	Monev Software LLC
	www.joomlaxtc.com
*/

defined( '_JEXEC' ) or die;

$image_file = $item[13];
$image_path = JPATH_ROOT.DS.$path.DS.$image_file;
$image_url = $live_site."$path/$image_file";

$thumb_file = 'IW_'.$module->id.'_'.md5($image_path)."_".$thumbw."x".$thumbh.'.png';
$thumb_path = JPATH_ROOT.DS.'cache'.DS.$thumb_file;
$thumbnail_url = $live_site.'cache/'.$thumb_file;

if (!JFile::exists($thumb_path)) { // Make thumbnail cache
	$width = $item[14][0];
	$height = $item[14][1];

	switch($item[14][2]) {
		case IMAGETYPE_GIF : $orig_img = imagecreatefromgif($image_path); break;
		case IMAGETYPE_JPEG: $orig_img = imagecreatefromjpeg($image_path); break;
		case IMAGETYPE_PNG : $orig_img = imagecreatefrompng($image_path); break;
		case IMAGETYPE_BMP : $orig_img = imagecreatefromwbmp($image_path); break;
	}

	// Compute new size

	if ($thumbar) {
		$newxsize = $thumbw;
		$newysize = $thumbh;
		if ($width < $height) { $newxsize = $newysize * ($width/$height);	}
		else { $newysize = $newxsize / ($width/$height); }
				
	  $new_img = function_exists("imagecreatetruecolor") ? imagecreatetruecolor($newxsize,$newysize) : imagecreate($newxsize,$newysize);
		
		if( function_exists("imagecopyresampled") ) {
			ImageCopyResampled($new_img, $orig_img, 0, 0, 0, 0, $newxsize, $newysize,$width, $height);
		}
		else {
			ImageCopyResized($new_img, $orig_img, 0, 0, 0, 0, $newxsize, $newysize,$width, $height);
		}
	}
	else {
		$maxX = $thumbw;
		$maxY = $thumbh;
		$newxsize = $maxX;
		$newysize = $maxY;
		if (($width*$maxY)<($height*$maxX)) {
			$newxsize = $newysize * ($width/$height);
			$adjustX = ($maxX - $newxsize)/2;
			$adjustY = 0;
		}
		else {
			$newysize = $newxsize / ($width/$height);
			$adjustX = 0;
			$adjustY = ($maxY - $newysize)/2;
		}
				
	  $new_img = function_exists("imagecreatetruecolor") ? imagecreatetruecolor($maxX,$maxY) : imagecreate($maxX,$maxY);
		
		imageAntiAlias($new_img,true);
		imagealphablending($new_img, true);
		imagesavealpha($new_img,true);
		imagefill( $new_img, 0,0, imagecolorallocatealpha($new_img, 255, 255, 255, 127) );
	
		if( function_exists("imagecopyresampled") ){
			ImageCopyResampled($new_img, $orig_img, $adjustX, $adjustY, 0, 0, $newxsize, $newysize,$width, $height);
		}
		else {
			ImageCopyResized($new_img, $orig_img, $adjustX, $adjustY, 0, 0, $newxsize, $newysize,$width, $height);
		}
	}
	// Save image
	imagepng($new_img,$thumb_path);
}

$size = $item[7];
$unim = array("B","KB","MB","GB","TB","PB");
$size = $size/pow(1024,$sizeformat);
$size = number_format($size,($sizeformat == 0 ? 0 : 1),".",",")." ".$unim[$sizeformat];
 
$itemhtml = str_replace( '{filename}', $image_file, $itemhtml );
$itemhtml = str_replace( '{image}', '<img src="'.$image_url.'" alt="'.$image_file.'" />', $itemhtml );
$itemhtml = str_replace( '{image_url}', $image_url, $itemhtml );
$itemhtml = str_replace( '{thumbnail}', '<img src="'.$thumbnail_url.'" alt="'.$image_file.'" />', $itemhtml );
$itemhtml = str_replace( '{thumbnail_url}', $thumbnail_url, $itemhtml );
$itemhtml = str_replace( '{size}', $size, $itemhtml );
$itemhtml = str_replace( '{adate}', date($dateformat,$item[8]), $itemhtml );
$itemhtml = str_replace( '{mdate}', date($dateformat,$item[9]), $itemhtml );
$itemhtml = str_replace( '{cdate}', date($dateformat,$item[10]), $itemhtml );
$itemhtml = str_replace( '{width}', $item[14][0], $itemhtml );
$itemhtml = str_replace( '{height}', $item[14][1], $itemhtml );
$itemhtml = str_replace( '{thumbwidth}', $thumbw, $itemhtml );
$itemhtml = str_replace( '{thumbheight}', $thumbh, $itemhtml );
?>