<?php
/*
	JoomlaXTC Image Wall

	version 1.0.0

	Copyright (C) 2008,2009,2010,2011 Monev Software LLC.	All Rights Reserved.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	THIS LICENSE IS NOT EXTENSIVE TO ACCOMPANYING FILES UNLESS NOTED.

	See COPYRIGHT.php for more information.
	See LICENSE.php for more information.

	Monev Software LLC
	www.joomlaxtc.com
*/

defined( '_JEXEC' ) or die;


//Core defs
$live_site = JURI::base();
$doc =&JFactory::getDocument();
JHTML::_( 'behavior.modal' );
jimport( 'joomla.filesystem.file' );
jimport( 'joomla.filesystem.folder' );
$moduleDir = 'mod_jxtc_imagewall';

//Parameters
$path = trim($params->get('path'),'/'); $path=trim($path,'/');
$filter = trim($params->get('filter'),'.');
$sortfield = $params->get('sortfield', 1);
$sortorder = $params->get('sortorder', 1);
$rows	= $params->get('rows', 1);
$columns = $params->get('columns',1);
$pages = $params->get('pages', 1);
$thumbw = $params->get('thumbw',80);
$thumbh = $params->get('thumbh',60);
$thumbar = $params->get('thumbar',1);
$dateformat = trim($params->get('dateformat', 'Y-m-d'));
$sizeformat = $params->get('sizeformat',0);
$modal = $params->get('modal',0);
$template	= $params->get('template','');
$moduletemplate = trim( $params->get('modulehtml','{mainarea}'));
$itemtemplate = trim( $params->get('html','{thumbnail}'));

if ($template && $template != -1) {
    $moduletemplate = file_get_contents(JPATH_ROOT . DS . 'modules' . DS . 'mod_jxtc_imagewall' . DS . 'templates' . DS . $template . DS . 'module.html');
    $itemtemplate = file_get_contents(JPATH_ROOT . DS . 'modules' . DS . 'mod_jxtc_imagewall' . DS . 'templates' . DS . $template . DS . 'element.html');
    if (file_exists(JPATH_ROOT . DS . 'modules' . DS . 'mod_jxtc_imagewall' . DS . 'templates' . DS . $template . DS . 'template.css')) {
        $doc->addStyleSheet($live_site . 'modules/mod_jxtc_imagewall/templates/' . $template . '/template.css', 'text/css');
    }
}

if ($modal) {
	JHTML::_('behavior.modal',  "a.modal", array('handler'=>'iframe'));
}

// Get files
$items = array();
$files = JFolder::files(JPATH_ROOT.DS.$path,$filter);
foreach ($files as $file) {
	$imageinfo = getimagesize(JPATH_ROOT.DS.$path.DS.$file);
	switch ($imageinfo[2]) {
		case IMAGETYPE_GIF:
		case IMAGETYPE_JPEG:
		case IMAGETYPE_PNG:
		case IMAGETYPE_BMP:
			$items[$file] = stat(JPATH_ROOT.DS.$path.DS.$file);
			$items[$file][13]=$file;
			$items[$file][14]=$imageinfo;
		break;
	}
}

switch ($sortfield) {
	case 0: // random
		$code = 'return rand(-1,1);';
		uasort($items, create_function('$a,$b', $code) );
	break;
	case 1: // name
		ksort($items );
	break;
	case 2: // creation date
		$code = $sortorder == 'a' ? 'return strnatcmp($a[10],$b[10]);' : 'return strnatcmp($b[10],$a[10]);';
		uasort($items, create_function('$a,$b', $code) );
	break;
	case 3: // modification date
		$code = $sortorder == 'a' ? 'return strnatcmp($a[9],$b[9]);' : 'return strnatcmp($b[9],$a[9]);';
		uasort($items, create_function('$a,$b', $code) );
	break;
	case 4: // size
		$code = $sortorder == 'a' ? 'return strnatcmp($a[7],$b[7]);' : 'return strnatcmp($b[7],$a[7]);';
		uasort($items, create_function('$a,$b', $code) );
	break;
}

$size = $columns*$rows*$pages;
$items = array_slice($items,0,$size,true);

require 'incl_render.php';

$contentparams = &JComponentHelper::getParams('com_content');
JPluginHelper::importPlugin('content');
$dispatcher =& JDispatcher::getInstance();
$item = new stdClass();
$item->text = $modulehtml;
$results = $dispatcher->trigger('onPrepareContent', array (&$item, &$contentparams, 0 ));
$modulehtml = $item->text;

echo '<div id="'.$jxtc.'">'.$modulehtml.'</div>';
?>
<div style="display:none"><a href="http://www.joomlaxtc.com">JoomlaXTC Image Wall - Copyright 2011 Monev Software LLC</a></div>